{ This unit and the associated Unit2 creates a StringGrid on a form and puts
a SpeedButton in the first row of each column. Each time a column width is
changed, the buttons are resized to fit the new widths and left positions.
This all works fine.

The problem I'm having is that when the mouse is positioned within 4 pixels
of a column edge, the cursor changes to a horizontal split-bar indicating the
column can be resized. This is normal and fine. However, if the user clicks the
left mouse button, the SpeedButton gets the click, not the grid.

I've tried about everything I can think of to pass the click to the grid so
that resizing can occur -- without sucess.

Any solutions would be greatly appriciated.

			Ted Kahn	70353,2603 (CompuServe)
      					tedkahn@interramp.com

 }
unit Butunit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Unit2, Buttons;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MySpeedButClick(Sender: TObject); virtual;
    {procedure ColWidthsChanged;}
  end;


var
  Form1: TForm1;
  StringGrid1: MyGrid;
 	spdHead: array[0..4] of TSpeedButton;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  k: integer;
  CRect: TRect;

begin
	StringGrid1 := MyGrid.Create(Self);
  StringGrid1.Parent := Self;
  StringGrid1.Width := 600;

  for k := 0 to 4 do begin
    spdHead[k] := TSpeedButton.Create(Self);
    spdHead[k].Parent := StringGrid1;
    spdHead[k].Caption :='Col ' + IntToStr(k);
    spdHead[k].AllowAllUp := true;
    spdHead[k].GroupIndex := 0;
    spdHead[k].Tag := k;
    spdHead[k].OnClick := MySpeedButClick;
    spdHead[k].Cursor := crUpArrow;
	end;
  for k := 0 to StringGrid1.ColCount - 1 do begin
    CRect := StringGrid1.CellRect(k,0);
    spdHead[k].SetBounds(CRect.Left, CRect.Top, (CRect.Right - CRect.Left),(CRect.Bottom - CRect.Top));
  end;

end;

procedure TForm1.MySpeedButClick(Sender: TObject);
var
  ACol: integer;

begin
  ACol := (sender as TSpeedButton).Tag;
  showmessage('Col ' + IntToStr(ACol) + ' clicked');
end;

{procedure TForm1.ColWidthsChanged;
var
  k: integer;
  CRect: TRect;

begin
 	ColWidthschanged;
	for k := 0 to StringGrid1.ColCount - 1 do begin
    CRect := StringGrid1.CellRect(k,0);
    spdHead[k].SetBounds(CRect.Left, CRect.Top, (CRect.Right - CRect.Left),(CRect.Bottom - CRect.Top));
  end;


end;
     }
end.
